import { BinaryLike } from "crypto";
import { RequestHandler } from "express";

export as namespace bitauth;

interface callback {
    (err?: Error, valid?: boolean): any;
}

export function generateSin(): {
    created: number;
    priv: string;
    pub: string;
    sin: string;
};
export function getPublicKeyFromPrivateKey(privkey: string | Uint8Array): string;
export function getSinFromPublicKey(pubkey: string | Uint8Array): string;
export function sign(data: string | Uint8Array, privkey: string | Uint8Array): Uint8Array;
export function verifySignature(
    data: string | Uint8Array,
    pubkey: string | Uint8Array,
    hexsignature: string | Uint8Array,
    callback?: callback,
    // eslint-disable-next-line @typescript-eslint/no-invalid-void-type
): boolean | void;
// eslint-disable-next-line @typescript-eslint/no-invalid-void-type
export function validateSin(sin: string, callback?: callback): boolean | void;
export function encrypt(password: BinaryLike, str: string): string;
export function decrypt(password: BinaryLike, str: string): string;
export const middleware: RequestHandler;

export {};
