import nunit = require("gulp-nunit-runner");

const stream = nunit({
    executable: "c:/Program Files/NUnit/bin",
    platform: "anycpu",
    teamcity: true,
    options: {
        test: ["TestSuite.Unit", "TestSuite.Integration"],
        testist: "TestsToRun.txt",
        run: ["TestSuite.Unit", "TestSuite.Integration"],
        runlist: "TestsToRun.txt",
        include: ["BaseLine", "Unit"],
        exclude: ["Database", "Network"],
        config: "Debug",
        process: "Single",
        domain: "None",
        framework: "net-1.1",
        x86: true,
        "dispose-runners": true,
        timeout: 1000,
        seed: 5150,
        workers: 5,
        stoponerror: true,
        wait: true,
        pause: true,
        work: "BuildArtifacts",
        output: "TestOutput.txt",
        err: "TestErrors.txt",
        result: "TestResult.xml",
        explore: "TestInfo.xml",
        noresult: true,
        labels: true,
        trace: "Off",
        shadowcopy: true,
        noshadow: true,
        teamcity: true,
        noheader: true,
        nocolor: true,
        verbose: true,
        nologo: true,
        nodots: true,
        apartment: "MTA",
        nothread: true,
        basepath: "src",
        privatebinpath: ["lib", "bin"],
        cleanup: true,
    },
});
