import { RemoteDataMessageObject } from "./RemoteDataMessage";

export default class RNRemoteMessage {
    static INSTANCE_ID_SCOPE: "HCM";

    static PRIORITY_UNKNOWN: 0;
    static PRIORITY_HIG: 1;
    static PRIORITY_NORMAL: 2;

    static COLLAPSEKEY: "collapseKey";
    static DATA: "data";
    static DATAOFMAP: "dataOfMap";
    static MESSAGEID: "messageId";
    static MESSAGETYPE: "messageType";
    static ORIGINALURGENCY: "originalUrgency";
    static URGENCY: "urgency";
    static TTL: "ttl";
    static SENTTIME: "sentTime";
    static TO: "to";
    static FROM: "from";
    static TOKEN: "token";
    static ANALYTIC_INFO: "analyticInfo";
    static ANALYTIC_INFO_MAP: "analyticInfoMap";

    static NOTIFICATION: {
        TITLE: "title";
        TITLELOCALIZATIONKEY: "titleLocalizationKey";
        TITLELOCALIZATIONARGS: "titleLocalizationArgs";
        BODYLOCALIZATIONKEY: "bodyLocalizationKey";
        BODYLOCALIZATIONARGS: "bodyLocalizationArgs";
        BODY: "body";
        ICON: "icon";
        SOUND: "Sound";
        TAG: "Tag";
        COLOR: "Color";
        CLICKACTION: "ClickAction";
        CHANNELID: "ChannelId";
        IMAGEURL: "ImageUrl";
        LINK: "Link";
        NOTIFYID: "NotifyId";
        WHEN: "When";
        LIGHTSETTINGS: "LightSettings";
        BADGENUMBER: "BadgeNumber";
        IMPORTANCE: "Importance";
        TICKER: "Ticker";
        VIBRATECONFIG: "vibrateConfig";
        VISIBILITY: "visibility";
        INTENTURI: "intentUri";
        ISAUTOCANCEL: "isAutoCancel";
        ISLOCALONLY: "isLocalOnly";
        ISDEFAULTLIGHT: "isDefaultLight";
        ISDEFAULTSOUND: "isDefaultSound";
        ISDEFAULTVIBRATE: "isDefaultVibrate";
    };

    constructor(options: RemoteDataMessageObject["msg"]);

    parseMsgAllAttribute(): string;
    getCollapseKey(): string;
    getData(): string;
    getDataOfMap(): string;
    getMessageId(): string;
    getMessageType(): string;
    getOriginalUrgency(): string;
    getUrgency(): string;
    getTtl(): number;
    getSentTime(): string;
    getTo(): string;
    getFrom(): string;
    getToken(): string;
    getAnalyticInfo(): string;
    getAnalyticInfoMap(): string;
    getNotificationTitle(): string;
    getTitleLocalizationKey(): string;
    getTitleLocalizationArgs(): string;
    getBodyLocalizationKey(): string;
    getBodyLocalizationArgs(): string;
    getBody(): string;
    getIcon(): string;
    getSound(): string;
    getTag(): string;
    getColor(): string | null;
    getClickAction(): string | null;
    getChannelId(): string | null;
    getImageUrl(): string;
    getLink(): string;
    getNotifyId(): string;
    getWhen(): string;
    getLightSettings(): string;
    getBadgeNumber(): string;
    getImportance(): string;
    getTicker(): string;
    getVibrateConfig(): any;
    getVisibility(): string;
    getIntentUri(): string;
    isAutoCancel(): string;
    isLocalOnly(): boolean;
    isDefaultLight(): boolean;
    isDefaultSound(): boolean;
    isDefaultVibrate(): boolean;
}
