interface KBMRobot {
    startJar(jre_version?: 6 | 7): void;
    stopJar(): void;
    press(key: Key): KBMRobot;
    release(key: Key): KBMRobot;
    type(key: Key, delay?: number): KBMRobot;
    typeString(str?: string, downDelay?: number, upDelay?: number): KBMRobot;
    sleep(ms: number): KBMRobot;
    mouseMove(x: number, y: number): KBMRobot;
    mousePress(button: MouseButton): KBMRobot;
    mouseRelease(button: MouseButton): KBMRobot;
    mouseClick(button: MouseButton, delay?: number): KBMRobot;
    mouseScroll(amount: number): KBMRobot;
    go(): Promise<void>;
}

declare const kbmRobot: KBMRobot;
export = kbmRobot;

type _MouseButton = "1" | "2" | "3";
type MouseButton = _MouseButton | `${_MouseButton}${_MouseButton}` | `${_MouseButton}${_MouseButton}${_MouseButton}`;

type Key =
    | "VK_ENTER"
    | "VK_BACK_SPACE"
    | "VK_TAB"
    | "VK_CANCEL"
    | "VK_CLEAR"
    | "VK_SHIFT"
    | "VK_CONTROL"
    | "VK_ALT"
    | "VK_PAUSE"
    | "VK_CAPS_LOCK"
    | "VK_ESCAPE"
    | "VK_SPACE"
    | "VK_PAGE_UP"
    | "VK_PAGE_DOWN"
    | "VK_END"
    | "VK_HOME"
    | "VK_LEFT"
    | "VK_UP"
    | "VK_RIGHT"
    | "VK_DOWN"
    | "VK_COMMA"
    | "VK_MINUS"
    | "VK_PERIOD"
    | "VK_SLASH"
    | "VK_0"
    | "VK_1"
    | "VK_2"
    | "VK_3"
    | "VK_4"
    | "VK_5"
    | "VK_6"
    | "VK_7"
    | "VK_8"
    | "VK_9"
    | "VK_SEMICOLON"
    | "VK_EQUALS"
    | "VK_A"
    | "VK_B"
    | "VK_C"
    | "VK_D"
    | "VK_E"
    | "VK_F"
    | "VK_G"
    | "VK_H"
    | "VK_I"
    | "VK_J"
    | "VK_K"
    | "VK_L"
    | "VK_M"
    | "VK_N"
    | "VK_O"
    | "VK_P"
    | "VK_Q"
    | "VK_R"
    | "VK_S"
    | "VK_T"
    | "VK_U"
    | "VK_V"
    | "VK_W"
    | "VK_X"
    | "VK_Y"
    | "VK_Z"
    | "VK_OPEN_BRACKET"
    | "VK_BACK_SLASH"
    | "VK_CLOSE_BRACKET"
    | "VK_NUMPAD0"
    | "VK_NUMPAD1"
    | "VK_NUMPAD2"
    | "VK_NUMPAD3"
    | "VK_NUMPAD4"
    | "VK_NUMPAD5"
    | "VK_NUMPAD6"
    | "VK_NUMPAD7"
    | "VK_NUMPAD8"
    | "VK_NUMPAD9"
    | "VK_MULTIPLY"
    | "VK_ADD"
    | "VK_SEPARATER"
    | "VK_SEPARATOR"
    | "VK_SUBTRACT"
    | "VK_DECIMAL"
    | "VK_DIVIDE"
    | "VK_DELETE"
    | "VK_NUM_LOCK"
    | "VK_SCROLL_LOCK"
    | "VK_F1"
    | "VK_F2"
    | "VK_F3"
    | "VK_F4"
    | "VK_F5"
    | "VK_F6"
    | "VK_F7"
    | "VK_F8"
    | "VK_F9"
    | "VK_F10"
    | "VK_F11"
    | "VK_F12"
    | "VK_F13"
    | "VK_F14"
    | "VK_F15"
    | "VK_F16"
    | "VK_F17"
    | "VK_F18"
    | "VK_F19"
    | "VK_F20"
    | "VK_F21"
    | "VK_F22"
    | "VK_F23"
    | "VK_F24"
    | "VK_PRINTSCREEN"
    | "VK_INSERT"
    | "VK_HELP"
    | "VK_META"
    | "VK_BACK_QUOTE"
    | "VK_QUOTE"
    | "VK_KP_UP"
    | "VK_KP_DOWN"
    | "VK_KP_LEFT"
    | "VK_KP_RIGHT"
    | "VK_DEAD_GRAVE"
    | "VK_DEAD_ACUTE"
    | "VK_DEAD_CIRCUMFLEX"
    | "VK_DEAD_TILDE"
    | "VK_DEAD_MACRON"
    | "VK_DEAD_BREVE"
    | "VK_DEAD_ABOVEDOT"
    | "VK_DEAD_DIAERESIS"
    | "VK_DEAD_ABOVERING"
    | "VK_DEAD_DOUBLEACUTE"
    | "VK_DEAD_CARON"
    | "VK_DEAD_CEDILLA"
    | "VK_DEAD_OGONEK"
    | "VK_DEAD_IOTA"
    | "VK_DEAD_VOICED_SOUND"
    | "VK_DEAD_SEMIVOICED_SOUND"
    | "VK_AMPERSAND"
    | "VK_ASTERISK"
    | "VK_QUOTEDBL"
    | "VK_LESS"
    | "VK_GREATER"
    | "VK_BRACELEFT"
    | "VK_BRACERIGHT"
    | "VK_AT"
    | "VK_COLON"
    | "VK_CIRCUMFLEX"
    | "VK_DOLLAR"
    | "VK_EURO_SIGN"
    | "VK_EXCLAMATION_MARK"
    | "VK_INVERTED_EXCLAMATION_MARK"
    | "VK_LEFT_PARENTHESIS"
    | "VK_NUMBER_SIGN"
    | "VK_PLUS"
    | "VK_RIGHT_PARENTHESIS"
    | "VK_UNDERSCORE"
    | "VK_WINDOWS"
    | "VK_CONTEXT_MENU"
    | "VK_FINAL"
    | "VK_CONVERT"
    | "VK_NONCONVERT"
    | "VK_ACCEPT"
    | "VK_MODECHANGE"
    | "VK_KANA"
    | "VK_KANJI"
    | "VK_ALPHANUMERIC"
    | "VK_KATAKANA"
    | "VK_HIRAGANA"
    | "VK_FULL_WIDTH"
    | "VK_HALF_WIDTH"
    | "VK_ROMAN_CHARACTERS"
    | "VK_ALL_CANDIDATES"
    | "VK_PREVIOUS_CANDIDATE"
    | "VK_CODE_INPUT"
    | "VK_JAPANESE_KATAKANA"
    | "VK_JAPANESE_HIRAGANA"
    | "VK_JAPANESE_ROMAN"
    | "VK_KANA_LOCK"
    | "VK_INPUT_METHOD_ON_OFF"
    | "VK_CUT"
    | "VK_COPY"
    | "VK_PASTE"
    | "VK_UNDO"
    | "VK_AGAIN"
    | "VK_FIND"
    | "VK_PROPS"
    | "VK_STOP"
    | "VK_COMPOSE"
    | "VK_ALT_GRAPH"
    | "VK_BEGIN"
    | "VK_UNDEFINED"
    | "ESC"
    | "F1"
    | "F2"
    | "F3"
    | "F4"
    | "F5"
    | "F6"
    | "F7"
    | "F8"
    | "F9"
    | "F10"
    | "F11"
    | "F12"
    | "CTRL"
    | "META"
    | "SUPER"
    | "ALT"
    | " "
    | "SPACE"
    | "LEFT"
    | "DOWN"
    | "RIGHT"
    | "UP"
    | "TAB"
    | "SHIFT"
    | "ENTER"
    | "\n"
    | "CAPS_LOCK"
    | "PRINT_SCREEN"
    | "SCROLL_LOCK"
    | "PAUSE_BREAK"
    | "BACKSPACE"
    | "DELETE"
    | "HOME"
    | "END"
    | "INSERT"
    | "PAGE_UP"
    | "PAGE_DOWN"
    | "NUM_LOCK"
    | "`"
    | "-"
    | "="
    | "["
    | "]"
    | "\\"
    | ";"
    | "'"
    | ","
    | "."
    | "/"
    | "KP_ADD"
    | "KP_-"
    | "KP_*"
    | "KP_/"
    | "KP_0"
    | "KP_."
    | "KP_1"
    | "KP_2"
    | "KP_3"
    | "KP_4"
    | "KP_5"
    | "KP_6"
    | "KP_7"
    | "KP_8"
    | "KP_9";
